/**********************************************************\
* Assault                                          Sandman *
*                                                          *
* Main code of The NET                                     *
*                                                          *
\**********************************************************/

/* Included Files */

//	#define __INCLUDED_RTS2_INC

	#define __INCLUDED_CNS_INC

//	#define __INCLUDED_RDR_INC

	#define __INCLUDED_CMD_INC

//	#define __INCLUDED_OBJ_INC

//	#define __INCLUDED_ITS_INC

	#define __INCLUDED_EXTRA_INC

	#define __INCLUDED_NETWORK_FH

#ifndef __TTF_DLL
#define __TTF_DLL
	import "ttf.DLL";
#endif

GLOBAL
	fnt_lucida_10;
	inct;
	incv;
	incg;
	incf;
END

	include "Fenix.fh";

	include "extra.inc";
	include "Network.fh";
	include "CMD.inc";
	include "CNS.inc";

PRIVATE

version;
string msg;

string stat[3];
string inc[3];

int i=0;
BEGIN


	name = "Main";

	version = NET_About();
	SetTitle("[Sandman]Network.DLL v" + version/100 + "." + version%100 + " test program");
	SetFps(40,0);
	SetMode(464,464,16);

    fnt_lucida_10		= load_ttf("lucon.ttf",10);

/* Console Setup */
	CNS_INIT(0,fnt_lucida_10,rgb(255,255,255),rgb(50,50,50),rgb(100,100,100),250);
	CNS_Text_Color(0,rgb(255,255,255));
	CNS_Text_Color(1,rgb(220,220,220));

	CONSOLE();

	say2("[CNS] Console v1.18");
	say2("[CNS] F1 - Act as server");
	say2("[CNS] F2 - Act as client");
	say2("[CNS] F5 - Send text");
	say2("[CNS] F6 - Send bigger text");
	say2("[CNS] F7 - Send variable of 100 bytes");
	say2("[CNS] F8 - Send graph");
	say2("[CNS] F9 - Send file");

	NET_Init(0,10,1);
	NET.ConsoleReports = 1;
	NET.ReturnNETDLLCommands = 1;

	set_text_color(rgb(255,255,255));

	write(0,10,310,0,"Total transferrate UP:");
	write(0,10,320,0,"Total transferrate DN:");
	write(0,10,330,0,"Total transferred UP:");
	write(0,10,340,0,"Total transferred DN:");

	write(0,10,360,0,"Transferrate UP:");
	write(0,10,370,0,"Transferrate DN:");
	write(0,10,380,0,"Transferred UP:");
	write(0,10,390,0,"Transferred DN:");
	write(0,10,400,0,"Status:");
	write(0,10,410,0,"Incoming:");


	write_int	(0,160,310,0,&NET.totaltransferrate_up);
	write_int	(0,160,320,0,&NET.totaltransferrate_down);
	write_int	(0,160,330,0,&NET.totaltransferred_up);
	write_int	(0,160,340,0,&NET.totaltransferred_down);

	write_int	(0,120,360,0,&NET.transferrate_up[0]);
	write_int	(0,120,370,0,&NET.transferrate_down[0]);
	write_int	(0,120,380,0,&NET.transferred_up[0]);
	write_int	(0,120,390,0,&NET.transferred_down[0]);
	write_string(0,120,400,0,&stat[0]);
	write_string(0,120,410,0,&inc[0]);

	write_int	(0,220,360,0,&NET.transferrate_up[1]);
	write_int	(0,220,370,0,&NET.transferrate_down[1]);
 	write_int	(0,220,380,0,&NET.transferred_up[1]);
	write_int	(0,220,390,0,&NET.transferred_down[1]);
	write_string(0,220,400,0,&stat[1]);
	write_string(0,220,410,0,&inc[1]);

	write_int	(0,320,360,0,&NET.transferrate_up[2]);
	write_int	(0,320,370,0,&NET.transferrate_down[2]);
 	write_int	(0,320,380,0,&NET.transferred_up[2]);
	write_int	(0,320,390,0,&NET.transferred_down[2]);
	write_string(0,320,400,0,&stat[2]);
	write_string(0,320,410,0,&inc[2]);

	write_int	(0,420,360,0,&NET.transferrate_up[3]);
	write_int	(0,420,370,0,&NET.transferrate_down[3]);
 	write_int	(0,420,380,0,&NET.transferred_up[3]);
	write_int	(0,420,390,0,&NET.transferred_down[3]);
	write_string(0,420,400,0,&stat[3]);
	write_string(0,420,410,0,&inc[3]);

	write(0,10,440,0,"FPS:");
   	write_int(0,40,440,0,&fps);

	write(0,154,440,1,"total");
	write(0,204,440,1,"vars");
	write(0,254,440,1,"graphs");
	write(0,304,440,1,"files");

	write_int(0,150,450,0,&inct);
	write_int(0,200,450,0,&incv);
	write_int(0,250,450,0,&incg);
	write_int(0,300,450,0,&incf);

	mouse.graph = new_map(6,6,8);
	map_clear(0,mouse.graph,rgb(255,255,255));

	drawing_map(0,mouse.graph);
	drawing_color(0);
	draw_line(0,0,7,7);

	nogeenloop();

	LOOP
		for(z=0; z<=3; z++)
			switch(NET.Status[z])
				case NET_STATUS_DISCONNECTED:
					stat[z] = "DISCN";
				end
				case NET_STATUS_INACTIVE:
					stat[z] = "INACT";
				end
				case NET_STATUS_ACTIVE:
					stat[z] = "ACTIV";
				end
				case NET_STATUS_ESTABLISHED:
					stat[z] = "ESTAB";
				end
				default:
					stat[z] = "UNKNW";
				end
			end
		end
		for(z=0; z<=3; z++)
			switch(NET.Incoming[z])
				case NET_STATUS_DISCONNECTED:
					inc[z] = "DISCN";
				end
				case NET_STATUS_INACTIVE:
					inc[z] = "INACT";
				end
				case NET_STATUS_ACTIVE:
					inc[z] = "ACTIV";
				end
				case NET_STATUS_ESTABLISHED:
					inc[z] = "ESTAB";
				end
				default:
					inc[z] = "UNKNW";
				end
			end
		end
		for(z=NET.MaxListenPorts; z<NET.MaxConnections ; z++)

			switch(NET.incoming[z])
				case NET_STATUS_DISCONNECTED:
					say2("Disconnected(" + z + ") " + NET_IPaddress(z) + " [" + NET_Hostname(z) + "]");
				end
				case NET_STATUS_INACTIVE:
				end
				case NET_STATUS_ACTIVE:
					while( len(msg = NET_Recv(z))>0)
						say2("Incoming(" + z + "): '" + msg + "'");
						inct++;
						if(msg=="VAR")
							incv++;
							RecvVar(z);
						end
						if(msg=="GRAPH")
							incg++;
							x=NET_RecvGraph(z);
							put(0,x,200,400);
						end
						if(msg=="FILE")
							say("CHECK6A");
							incf++;
							x=NET_RecvFile(z,"TESTSERVER.TXT");
						end
					end 
				end
				case NET_STATUS_ESTABLISHED:
					NET_Separator(z,chr(13)+chr(10),2);
					say2("Connected(" + z + "): " + NET_IPaddress(z) + " [" + NET_Hostname(z) + "]");
				end
				default:
					say2("Unknown("  + z + "): code: " + NET.incoming[z]);
				end
			end
		end
		frame;
	END

END

PROCESS nogeenloop()
PRIVATE
byte pointer d;
BEGIN

	say(load_fnt("C:\fdwe"));

	d = alloc(100);

	LOOP
		if(key(_f1))
			//CNS("net server");
			NET_Listen(4555,1);
			while(key(_f1)) frame; end
		end
		if(key(_f2))
			//CNS("net client");
			x=NET_Open("localhost",4555,1);
			NET_Send(x,"hoi");
			while(key(_f2)) frame; end
		end
		if(key(_f5))
			inct++;
			NET_Send(1,"THIS IS A TEST");
		//	while(key(_f5)) frame; end
		end
		if(key(_f6))
			inct++;
			NET_Send(1,"THIS IS A BIGGER TEST THIS IS A BIGGER TEST THIS IS A BIGGER TEST THIS IS A BIGGER TEST THIS IS A BIGGER TEST THIS IS A BIGGER TEST THIS IS A BIGGER TEST THIS IS A BIGGER TEST");
		//	while(key(_f5)) frame; end
		end
		if(key(_f7))
			inct++;
			incv++;
			NET_Send(1,"VAR",true);
			NET_SendVar(1,d,100);
		//	while(key(_f5)) frame; end
		end
		if(key(_f8))
			inct++;
			incg++;
			NET_Send(1,"GRAPH",true);
			NET_SendGraph(1,0,mouse.graph);
		//	while(key(_f5)) frame; end
		end
		if(key(_f9))
			inct++;
			incf++;
			NET_Send(1,"FILE",true);
			NET_SendFile(1,"TESTCLIENT.txt");
		//	while(key(_f6)) frame; end
		end
		frame;
	END

END

Int RecvVar(conn)
Private
byte pointer d;
Begin
	d = alloc(100);
	x= NET_RecvVar(conn,d,100);
	free(d);
	return x;
End